#!/usr/bin/perl

@classes = glob("*.h");
@methods = ();

open(OUT, ">visitor.h") or die("No foi possvel criar o arquivo visitor.h!\n");

print OUT "#ifndef VISITOR_H\n";
print OUT "#define VISITOR_H\n\n";
print OUT "#include \"visitorreturn.h\"\n\n";
foreach $class (@classes)
{
	if ($class eq "srcposition.h" || $class =~ m/visitor/i)
		{ next; }

	open(TEMP, "$class") or die("No foi possvel abrir o arquivo $class!\n");
	$line = <TEMP>;
	close(TEMP);

	@names = split(/\#ifndef\s+/, $line);
	$class = "\L$names[1]";
	@names = split(/_/, $class);
	pop(@names);

	$class ="";
	foreach $name (@names)
		{ $name = "\u$name"; $class .= $name;}
	
	print OUT "class $class;\n";

	push(@CLASSES, $class);
}


print OUT "class Visitor {\n";

print OUT "\tpublic:\n";
print OUT "\t\tvirtual ~Visitor() {}\n";
foreach $class (@CLASSES)
{
	 print OUT "\t\tvirtual VisitorReturn *visit$class($class *\l$class) = 0;\n";
	 push(@methods, "visit$class($class *\l$class)");
}

print OUT "};\n\n";
print OUT "#endif\n";
close(OUT);

# Gera visitor
open(SCRIPT, ">createNewVisitor.pl") or die("No foi possvel criar createNewVisitor.pl!\n");

print SCRIPT "#!/usr/bin/perl\n\n";
print SCRIPT "die(\"Uso: createNewVisitor.pl <VisitorName>\\n\") if (\$\#ARGV != 0);\n";
print SCRIPT "\$class = \$ARGV[0];\n";
print SCRIPT "\@nomes = split(/(\?=[A-Z])/, \$class);\n";
print SCRIPT "\$define = join(\"_\", \@nomes) . \"_H\";\n";
print SCRIPT "\$define = \"\\U\$define\";\n";

## Header
print SCRIPT "open(OUT, \">\\L\$class.h\") or die(\"no foi possvel abrir \\L\$class.h!\\n\");\n";
print SCRIPT "print OUT \"#ifndef \$define\\n\";\n";
print SCRIPT "print OUT \"#define \$define\\n\\n\";\n\n";

print SCRIPT "print OUT \"#include \\\"visitor.h\\\"\\n\\n\";\n\n";

print SCRIPT "print OUT \"class \$class : public Visitor {\\n\";\n";

print SCRIPT "print OUT \"\\tpublic:\\n\";\n";
print SCRIPT "print OUT \"\\t\\tvirtual ~\$class() {}\\n\";\n";
foreach $method (@methods)
	{ print SCRIPT "print OUT \"\\t\\tVisitorReturn *$method;\\n\";\n";}

print SCRIPT "print OUT \"};\\n\\n\";\n\n";
print SCRIPT "print OUT \"#endif\\n\";\n";
print SCRIPT "close(OUT);\n\n";

## CPP
print SCRIPT "open(OUT, \">\\L\$class.cpp\") or die(\"no foi possvel abrir \\L\$class.cpp!\\n\");\n";
print SCRIPT "print OUT \"#include \\\"\\L\$class.h\\\"\\n\";\n";
print SCRIPT "print OUT \"#include \\\"protomake.h\\\"\\n\\n\";\n\n";

foreach $method (@methods)
	{ print SCRIPT "print OUT \"VisitorReturn *\$class\\:\\:$method {\\n\tVisitorReturn *v;\\n\treturn v;\\n}\\n\\n\";\n";}
print SCRIPT "close(OUT);\n";

close(SCRIPT);
