%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cpmsocket.h"
#include "cpmaddrParse.h"

int lines = 0;

extern int addrerror(const char *msg);
%}

white	[ \t]
ip		[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}
host	[a-zA-Z][a-zA-Z0-9]*(\.[a-zA-Z][a-zA-Z0-9]*)*
port	[0-9]+

%option noyywrap

%%

#.*\n										{ printf("Comentrio!!!\n"); lines++; }
\[{white}*Protocol{white}+Address{white}*\]	{ addrlval.string = strdup(yytext); return tPROTOCOL_ADDR; }
\[{white}*Constant{white}+Address{white}+	{ addrlval.string = strdup(yytext); return tCONST_ADDR; }
tcp											{ return tTCP; }
udp											{ return tUDP; }
[a-zA-Z0-9]+{white}*\]						{ addrlval.string = strdup(yytext); return tCONST_ADDR_NAME; }
ip{white}*={white}*							{ return tIP; }
{ip}										{ addrlval.string = strdup(yytext); return tIP_NUMBER; }
{host}										{ addrlval.string = strdup(yytext); return tHOST; }
port{white}*={white}*						{ return tPORT; }
{port}										{ addrlval.number = atoi(yytext); return tPORT_NUMBER; }
trans{white}*={white}*						{ return tTRANS; }
.											{ addrerror("Token invlido!"); return -1; }
\n											{ /* blanks */ lines++; }

%%
