#ifndef _C_PM_QUEUE_H_
#define _C_PM_QUEUE_H_

#define CPM_QUEUE_OK 0
#define CPM_QUEUE_ERR -1

#include "genericmessage.h"
#include "cpmthread.h"
#include "cpmsocket.h"

typedef struct MessageList {
    GenericMessage *gm;
    struct MessageList *next;
} MessageList;

typedef struct PMQueue {
    int qntMsgTypes;
    pmmutex_t *rowMutex;
    pmcond_t *newData;
	pmmutex_t *totalNewMutex;
	unsigned totalNew;
    MessageList *queues;
} PMQueue;


PMQueue *pmqueue_new(int qntMsgTypes);
void pmqueue_destroy(PMQueue **queue);
int pmqueue_enqueue(PMQueue *queue, GenericMessage *message);
GenericMessage *pmqueue_dequeue(PMQueue *queue, unsigned totalCodes, int *codes, PMSocket *sock);

#endif
