#ifndef _C_PM_SOCKET_H_
#define _C_PM_SOCKET_H_

#include <stdint.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define PMSOCKET_ERROR -1
#ifndef _PM_BYTE_TYPE_
#define _PM_BYTE_TYPE_
    typedef unsigned char byte;
#endif

typedef enum transport {INVALID, TCP, UDP} transport;

typedef struct PMSocket {
    int socketFD;
    struct sockaddr_in addr;
    transport trans;
	//campos relevantes apenas para transport == TCP
	int var;
	int connected;
} PMSocket;

#define PMSOCKET_EQUAL(x,y) (x != NULL && y != NULL && x->trans == y->trans && \
                            x->addr.sin_addr.s_addr == y->addr.sin_addr.s_addr && \
							x->addr.sin_port == y->addr.sin_port)

PMSocket *pmsocket_new(const char *address, uint16_t port, transport trans);
int pmsocket_bind(PMSocket *pmSocket);
int pmsocket_connect(PMSocket *pmSocket);
PMSocket *pmsocket_accept(PMSocket *pmSocket, int queue);
int pmsocket_close(PMSocket *pmSocket);
int pmsocket_send(const PMSocket *pmSocket, const byte *data, uint32_t length);
PMSocket *pmsocket_recv(const PMSocket *pmSocket, byte *data, uint32_t length, PMSocket *sender);


#endif
