#ifndef _C_PM_SOCKET_LIST_H_
#define _C_PM_SOCKET_LIST_H_
#include "cpmsocket.h"
#include "cpmthread.h"

typedef struct PMSocketListNode{
	PMSocket *socket;
	struct PMSocketListNode *next;
} PMSocketListNode;

typedef PMSocketListNode pmsocketlist_iterator;

typedef struct PMSocketList {
	PMSocketListNode *head;
	pmmutex_t mutex;
	int maxfd;
} PMSocketList;

PMSocketList *pmsocketlist_new();
void pmsocketlist_destroy(PMSocketList *pmsl);
int pmsocketlist_remove(PMSocketList *pmsl, PMSocket *sock);
int pmsocketlist_add(PMSocketList *pmsl, PMSocket *sock);

void pmsocketlist_lock(PMSocketList *pmsl);
void pmsocketlist_unlock(PMSocketList *pmsl);


#endif
