#ifndef _C_PM_THREAD_H_
#define _C_PM_THREAD_H_

#define PMTHREAD_ERROR -1

#include <pthread.h>

typedef pthread_t pmthread_t;
typedef pthread_mutex_t pmmutex_t;
typedef pthread_cond_t pmcond_t;

// Threads
pmthread_t pmthread_new(void *(*thread)(void *args), void *args);
int pmthread_destroy(pmthread_t threadID);
int pmthread_wait(pmthread_t threadID);

// Mutexs
pmmutex_t pmmutex_new();
int pmmutex_destroy(pmmutex_t *mutex);
int pmmutex_lock(pmmutex_t *mutex);
int pmmutex_trylock(pmmutex_t *mutex);
int pmmutex_unlock(pmmutex_t *mutex);

// Conditional variables
pmcond_t pmcond_new();
int pmcond_destroy(pmcond_t *cond);
int pmcond_wait(pmcond_t *cond, pmmutex_t *mutex);
int pmcond_signal(pmcond_t *cond);
int pmcond_broadcast(pmcond_t *cond);

#endif

