#ifndef ACT_STATEMENT_H
#define ACT_STATEMENT_H

#include "simplestatement.h"
#include "identifier.h"
#include "expression.h"

class ActStatement : public SimpleStatement {
	private:
		Identifier *identifier;
		Expression *expression;

	public:
		ActStatement(SrcPosition *position, Identifier *identifier, Expression *expression)
				: SimpleStatement(position), identifier(identifier), expression(expression) {}

		ActStatement(const ActStatement& actStatement) : SimpleStatement(actStatement.position) {
			*(this) = actStatement;
		}

		virtual ~ActStatement() {
			delete this->identifier;
			delete this->expression;
		}

		Identifier *getIdentifier() {
			return this->identifier;
		}

		Expression *getExpression() {
			return this->expression;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitActStatement(this);
		}

		virtual Ast& clone() const {
			return *(new ActStatement(new SrcPosition(*(this->position)),
					 this->identifier ? dynamic_cast<Identifier*>(&(this->identifier->clone())) : 0,
					 this->expression ? dynamic_cast<Expression*>(&(this->expression->clone())) : 0));
		}
};

#endif
