#include <typeinfo>
#include "behaviorstatement.h"
using namespace std;

Ast& BehaviorStatement::operator = (const Ast& ast) {
	const BehaviorStatement& behaviorStatement = dynamic_cast<const BehaviorStatement&>(ast);

	Ast::operator=(ast);
	this->behavior = behaviorStatement.behavior ? dynamic_cast<Identifier*>(&(behaviorStatement.behavior->clone())) : 0;
	this->function = behaviorStatement.function ? dynamic_cast<Identifier*>(&(behaviorStatement.function->clone())) : 0;
	this->expressionList = behaviorStatement.expressionList ? dynamic_cast<ExpressionList*>(&(behaviorStatement.expressionList->clone())) : 0;

	return *(this);
}

bool BehaviorStatement::operator == (const Ast& ast) const {
	bool result = false;
	const BehaviorStatement& behaviorStatement = dynamic_cast<const BehaviorStatement&>(ast);

	if (typeid(ast) != typeid(BehaviorStatement))
		return false;

	if (this->expressionList && this->behavior && this->function)
		result = (*(this->expressionList) == *(behaviorStatement.expressionList) &&
				  *(this->behavior) == *(behaviorStatement.behavior) &&
				  *(this->function) == *(behaviorStatement.function));

	return result;
}

