#!/usr/bin/perl

die("Uso: createNewVisitor.pl <VisitorName>\n") if ($#ARGV != 0);
$class = $ARGV[0];
@nomes = split(/(?=[A-Z])/, $class);
$define = join("_", @nomes) . "_H";
$define = "\U$define";
open(OUT, ">\L$class.h") or die("no foi possvel abrir \L$class.h!\n");
print OUT "#ifndef $define\n";
print OUT "#define $define\n\n";

print OUT "#include \"visitor.h\"\n\n";

print OUT "class $class : public Visitor {\n";
print OUT "\tpublic:\n";
print OUT "\t\tvirtual ~$class() {}\n";
print OUT "\t\tVisitorReturn *visitAction(Action *action);\n";
print OUT "\t\tVisitorReturn *visitActStatement(ActStatement *actStatement);\n";
print OUT "\t\tVisitorReturn *visitArrayReference(ArrayReference *arrayReference);\n";
print OUT "\t\tVisitorReturn *visitArrayType(ArrayType *arrayType);\n";
print OUT "\t\tVisitorReturn *visitAssignStatement(AssignStatement *assignStatement);\n";
print OUT "\t\tVisitorReturn *visitAst(Ast *ast);\n";
print OUT "\t\tVisitorReturn *visitBehavior(Behavior *behavior);\n";
print OUT "\t\tVisitorReturn *visitBehaviorStatement(BehaviorStatement *behaviorStatement);\n";
print OUT "\t\tVisitorReturn *visitBinaryExpression(BinaryExpression *binaryExpression);\n";
print OUT "\t\tVisitorReturn *visitDeclaration(Declaration *declaration);\n";
print OUT "\t\tVisitorReturn *visitDoStatement(DoStatement *doStatement);\n";
print OUT "\t\tVisitorReturn *visitExpression(Expression *expression);\n";
print OUT "\t\tVisitorReturn *visitExpressionList(ExpressionList *expressionList);\n";
print OUT "\t\tVisitorReturn *visitFieldDeclaration(FieldDeclaration *fieldDeclaration);\n";
print OUT "\t\tVisitorReturn *visitFieldReference(FieldReference *fieldReference);\n";
print OUT "\t\tVisitorReturn *visitFieldType(FieldType *fieldType);\n";
print OUT "\t\tVisitorReturn *visitGuard(Guard *guard);\n";
print OUT "\t\tVisitorReturn *visitGuardedStatement(GuardedStatement *guardedStatement);\n";
print OUT "\t\tVisitorReturn *visitGuardExpression(GuardExpression *guardExpression);\n";
print OUT "\t\tVisitorReturn *visitGuardReceive(GuardReceive *guardReceive);\n";
print OUT "\t\tVisitorReturn *visitGuardTimeout(GuardTimeout *guardTimeout);\n";
print OUT "\t\tVisitorReturn *visitIdentifier(Identifier *identifier);\n";
print OUT "\t\tVisitorReturn *visitIdentifierList(IdentifierList *identifierList);\n";
print OUT "\t\tVisitorReturn *visitIfStatement(IfStatement *ifStatement);\n";
print OUT "\t\tVisitorReturn *visitImport(Import *import);\n";
print OUT "\t\tVisitorReturn *visitIntegerLiteral(IntegerLiteral *integerLiteral);\n";
print OUT "\t\tVisitorReturn *visitLeftSide(LeftSide *leftSide);\n";
print OUT "\t\tVisitorReturn *visitLeftSideList(LeftSideList *leftSideList);\n";
print OUT "\t\tVisitorReturn *visitMessage(Message *message);\n";
print OUT "\t\tVisitorReturn *visitMultipleArrayReference(MultipleArrayReference *multipleArrayReference);\n";
print OUT "\t\tVisitorReturn *visitProcess(Process *process);\n";
print OUT "\t\tVisitorReturn *visitProgram(Program *program);\n";
print OUT "\t\tVisitorReturn *visitRangeType(RangeType *rangeType);\n";
print OUT "\t\tVisitorReturn *visitReceiveStatement(ReceiveStatement *receiveStatement);\n";
print OUT "\t\tVisitorReturn *visitSendStatement(SendStatement *sendStatement);\n";
print OUT "\t\tVisitorReturn *visitSequentialAction(SequentialAction *sequentialAction);\n";
print OUT "\t\tVisitorReturn *visitSequentialBehavior(SequentialBehavior *sequentialBehavior);\n";
print OUT "\t\tVisitorReturn *visitSequentialDeclaration(SequentialDeclaration *sequentialDeclaration);\n";
print OUT "\t\tVisitorReturn *visitSequentialExpressionList(SequentialExpressionList *sequentialExpressionList);\n";
print OUT "\t\tVisitorReturn *visitSequentialFieldDeclaration(SequentialFieldDeclaration *sequentialFieldDeclaration);\n";
print OUT "\t\tVisitorReturn *visitSequentialGuardedStatement(SequentialGuardedStatement *sequentialGuardedStatement);\n";
print OUT "\t\tVisitorReturn *visitSequentialIdentifierList(SequentialIdentifierList *sequentialIdentifierList);\n";
print OUT "\t\tVisitorReturn *visitSequentialImport(SequentialImport *sequentialImport);\n";
print OUT "\t\tVisitorReturn *visitSequentialLeftSideList(SequentialLeftSideList *sequentialLeftSideList);\n";
print OUT "\t\tVisitorReturn *visitSequentialMessage(SequentialMessage *sequentialMessage);\n";
print OUT "\t\tVisitorReturn *visitSequentialProcess(SequentialProcess *sequentialProcess);\n";
print OUT "\t\tVisitorReturn *visitSequentialStatement(SequentialStatement *sequentialStatement);\n";
print OUT "\t\tVisitorReturn *visitSimpleAction(SimpleAction *simpleAction);\n";
print OUT "\t\tVisitorReturn *visitSimpleArrayReference(SimpleArrayReference *simpleArrayReference);\n";
print OUT "\t\tVisitorReturn *visitSimpleBehavior(SimpleBehavior *simpleBehavior);\n";
print OUT "\t\tVisitorReturn *visitSimpleDeclaration(SimpleDeclaration *simpleDeclaration);\n";
print OUT "\t\tVisitorReturn *visitSimpleExpressionList(SimpleExpressionList *simpleExpressionList);\n";
print OUT "\t\tVisitorReturn *visitSimpleFieldDeclaration(SimpleFieldDeclaration *simpleFieldDeclaration);\n";
print OUT "\t\tVisitorReturn *visitSimpleGuardedStatement(SimpleGuardedStatement *simpleGuardedStatement);\n";
print OUT "\t\tVisitorReturn *visitSimpleIdentifierList(SimpleIdentifierList *simpleIdentifierList);\n";
print OUT "\t\tVisitorReturn *visitSimpleImport(SimpleImport *simpleImport);\n";
print OUT "\t\tVisitorReturn *visitSimpleLeftSideList(SimpleLeftSideList *simpleLeftSideList);\n";
print OUT "\t\tVisitorReturn *visitSimpleMessage(SimpleMessage *simpleMessage);\n";
print OUT "\t\tVisitorReturn *visitSimpleProcess(SimpleProcess *simpleProcess);\n";
print OUT "\t\tVisitorReturn *visitSimpleStatement(SimpleStatement *simpleStatement);\n";
print OUT "\t\tVisitorReturn *visitSkipStatement(SkipStatement *skipStatement);\n";
print OUT "\t\tVisitorReturn *visitStartStatement(StartStatement *startStatement);\n";
print OUT "\t\tVisitorReturn *visitStatement(Statement *statement);\n";
print OUT "\t\tVisitorReturn *visitStopStatement(StopStatement *stopStatement);\n";
print OUT "\t\tVisitorReturn *visitStringLiteral(StringLiteral *stringLiteral);\n";
print OUT "\t\tVisitorReturn *visitType(Type *type);\n";
print OUT "\t\tVisitorReturn *visitUnaryExpression(UnaryExpression *unaryExpression);\n";
print OUT "};\n\n";

print OUT "#endif\n";
close(OUT);

open(OUT, ">\L$class.cpp") or die("no foi possvel abrir \L$class.cpp!\n");
print OUT "#include \"\L$class.h\"\n";
print OUT "#include \"protomake.h\"\n\n";

print OUT "VisitorReturn *$class\:\:visitAction(Action *action) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitActStatement(ActStatement *actStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitArrayReference(ArrayReference *arrayReference) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitArrayType(ArrayType *arrayType) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitAssignStatement(AssignStatement *assignStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitAst(Ast *ast) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitBehavior(Behavior *behavior) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitBehaviorStatement(BehaviorStatement *behaviorStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitBinaryExpression(BinaryExpression *binaryExpression) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitDeclaration(Declaration *declaration) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitDoStatement(DoStatement *doStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitExpression(Expression *expression) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitExpressionList(ExpressionList *expressionList) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitFieldDeclaration(FieldDeclaration *fieldDeclaration) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitFieldReference(FieldReference *fieldReference) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitFieldType(FieldType *fieldType) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitGuard(Guard *guard) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitGuardedStatement(GuardedStatement *guardedStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitGuardExpression(GuardExpression *guardExpression) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitGuardReceive(GuardReceive *guardReceive) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitGuardTimeout(GuardTimeout *guardTimeout) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitIdentifier(Identifier *identifier) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitIdentifierList(IdentifierList *identifierList) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitIfStatement(IfStatement *ifStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitImport(Import *import) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitIntegerLiteral(IntegerLiteral *integerLiteral) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitLeftSide(LeftSide *leftSide) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitLeftSideList(LeftSideList *leftSideList) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitMessage(Message *message) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitMultipleArrayReference(MultipleArrayReference *multipleArrayReference) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitProcess(Process *process) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitProgram(Program *program) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitRangeType(RangeType *rangeType) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitReceiveStatement(ReceiveStatement *receiveStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSendStatement(SendStatement *sendStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSequentialAction(SequentialAction *sequentialAction) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSequentialBehavior(SequentialBehavior *sequentialBehavior) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSequentialDeclaration(SequentialDeclaration *sequentialDeclaration) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSequentialExpressionList(SequentialExpressionList *sequentialExpressionList) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSequentialFieldDeclaration(SequentialFieldDeclaration *sequentialFieldDeclaration) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSequentialGuardedStatement(SequentialGuardedStatement *sequentialGuardedStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSequentialIdentifierList(SequentialIdentifierList *sequentialIdentifierList) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSequentialImport(SequentialImport *sequentialImport) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSequentialLeftSideList(SequentialLeftSideList *sequentialLeftSideList) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSequentialMessage(SequentialMessage *sequentialMessage) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSequentialProcess(SequentialProcess *sequentialProcess) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSequentialStatement(SequentialStatement *sequentialStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleAction(SimpleAction *simpleAction) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleArrayReference(SimpleArrayReference *simpleArrayReference) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleBehavior(SimpleBehavior *simpleBehavior) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleDeclaration(SimpleDeclaration *simpleDeclaration) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleExpressionList(SimpleExpressionList *simpleExpressionList) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleFieldDeclaration(SimpleFieldDeclaration *simpleFieldDeclaration) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleGuardedStatement(SimpleGuardedStatement *simpleGuardedStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleIdentifierList(SimpleIdentifierList *simpleIdentifierList) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleImport(SimpleImport *simpleImport) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleLeftSideList(SimpleLeftSideList *simpleLeftSideList) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleMessage(SimpleMessage *simpleMessage) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleProcess(SimpleProcess *simpleProcess) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSimpleStatement(SimpleStatement *simpleStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitSkipStatement(SkipStatement *skipStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitStartStatement(StartStatement *startStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitStatement(Statement *statement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitStopStatement(StopStatement *stopStatement) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitStringLiteral(StringLiteral *stringLiteral) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitType(Type *type) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
print OUT "VisitorReturn *$class\:\:visitUnaryExpression(UnaryExpression *unaryExpression) {\n	VisitorReturn *v;\n	return v;\n}\n\n";
close(OUT);
