#ifndef DO_STATEMENT_H
#define DO_STATEMENT_H

#include "simplestatement.h"
#include "simpleguardedstatement.h"

class DoStatement : public SimpleStatement {
	private:
		SimpleGuardedStatement *simpleGuardedStatement;

	public:
		DoStatement(SrcPosition *position, SimpleGuardedStatement *simpleGuardedStatement)
				: SimpleStatement(position), simpleGuardedStatement(simpleGuardedStatement) {}

		DoStatement(const DoStatement& doStatement) : SimpleStatement(doStatement.position) {
			*(this) = doStatement;
		}

		virtual ~DoStatement() {
			delete this->simpleGuardedStatement;
		}

		SimpleGuardedStatement *getSimpleGuardedStatement() {
			return this->simpleGuardedStatement;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitDoStatement(this);
		}

		virtual Ast& clone() const {
			return *(new DoStatement(new SrcPosition(*(this->position)),
					 this->simpleGuardedStatement ?
					 	dynamic_cast<SimpleGuardedStatement*>(&(this->simpleGuardedStatement->clone())) : 0));
		}
};

#endif
