#include "fieldreference.h"

Ast& FieldReference::operator = (const Ast& ast) {
	const FieldReference& fieldReference = dynamic_cast<const FieldReference&>(ast);

	Expression::operator=(ast);

	this->msgId = fieldReference.msgId ? dynamic_cast<Identifier*>(&(fieldReference.msgId->clone())) : 0;
	this->fieldId = fieldReference.fieldId ? dynamic_cast<Identifier*>(&(fieldReference.fieldId->clone())): 0;

	return (*this);
}

bool FieldReference::operator == (const Ast& ast) const {
	const FieldReference& fieldReference = dynamic_cast<const FieldReference&>(ast);

	bool result = false;
	if(this->msgId && this->fieldId) {
		result = (*(this->msgId) == *(fieldReference.msgId) &&
					 *(this->fieldId) == *(fieldReference.fieldId));
	}

	return result && Expression::operator==(ast);
}
