#ifndef GUARD_RECEIVE_H
#define GUARD_RECEIVE_H

#include "guard.h"
#include "receivestatement.h"

class GuardReceive : public Guard {
	private:
		ReceiveStatement *receiveStatement;

	public:
		GuardReceive(SrcPosition *position, ReceiveStatement *receiveStatement)
				: Guard(position), receiveStatement(receiveStatement) {}

		GuardReceive(const GuardReceive& guardReceive) : Guard(guardReceive.position) {
			*(this) = guardReceive;
		}

		virtual ~GuardReceive() {
			delete this->receiveStatement;
		}

		ReceiveStatement *getReceiveStatement() {
			return this->receiveStatement;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitGuardReceive(this);
		}

		virtual Ast& clone() const {
			return *(new GuardReceive(new SrcPosition(*(this->position)),
					 this->receiveStatement ? dynamic_cast<ReceiveStatement*>(&(this->receiveStatement->clone())) : 0));
		}
};

#endif
