#ifndef INTEGER_LITERAL_H
#define INTEGER_LITERAL_H
#include "expression.h"


class IntegerLiteral : public Expression {
	private:
		int value;
	public:
		IntegerLiteral(SrcPosition *position, int value) : Ast(position), Expression(position), value(value) {}
		IntegerLiteral(const IntegerLiteral& integerLiteral) : Ast(position), Expression(position), value(integerLiteral.value) {}
		virtual ~IntegerLiteral() {}

		int getValue() const {
			return this->value;
		}

		virtual Ast& operator = (const Ast& ast);

		virtual bool operator == (const Ast& ast) const;
		
		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitIntegerLiteral(this);
		}

		virtual Ast& clone() const {
			return *(new IntegerLiteral(new SrcPosition(*this->position), this->value));
		}
};

#endif
