#include "receivestatement.h"

Ast& ReceiveStatement::operator = (const Ast& ast) {
	const ReceiveStatement& receiveStatement = dynamic_cast<const ReceiveStatement&>(ast);

	Statement::operator=(ast);

	this->msgId = receiveStatement.msgId ? dynamic_cast<Identifier*>(&(receiveStatement.msgId->clone())) : 0;
	this->addrId = receiveStatement.addrId ? dynamic_cast<Identifier*>(&(receiveStatement.addrId->clone())) : 0;
	this->tcp = receiveStatement.tcp;

	return (*this);
}

bool ReceiveStatement::operator == (const Ast& ast) const {
	const ReceiveStatement& receiveStatement = dynamic_cast<const ReceiveStatement&>(ast);

	bool result = false;
	if(this->msgId && this->addrId) {
		result = (*(this->msgId) == *(receiveStatement.msgId) && 
					 *(this->addrId) == *(receiveStatement.addrId) &&
					 this->tcp == receiveStatement.tcp);
	}
	
	return result && Statement::operator==(ast);
}
