#include <typeinfo>
#include "sequentialbehavior.h"
using namespace std;

Ast& SequentialBehavior::operator = (const Ast& ast) {
	const SequentialBehavior& sequentialBehavior = dynamic_cast<const SequentialBehavior&>(ast);

	Behavior::operator=(ast);
	this->behavior = sequentialBehavior.behavior ? dynamic_cast<Behavior*>(&(sequentialBehavior.behavior->clone())) : 0;
	this->simpleBehavior = sequentialBehavior.simpleBehavior ? dynamic_cast<SimpleBehavior*>(&(sequentialBehavior.simpleBehavior->clone())) : 0;

	return *(this);
}

bool SequentialBehavior::operator == (const Ast& ast) const {
	bool result = false;
	const SequentialBehavior& sequentialBehavior = dynamic_cast<const SequentialBehavior&>(ast);

	if (typeid(ast) != typeid(SequentialBehavior))
		return false;

	if (this->behavior && this->simpleBehavior)
		result = (*(this->behavior) == *(sequentialBehavior.behavior) &&
				  *(this->simpleBehavior) == *(sequentialBehavior.simpleBehavior));

	return result && Behavior::operator==(ast);
}

