#include <typeinfo>
#include "sequentialidentifierlist.h"
using namespace std;

Ast& SequentialIdentifierList::operator = (const Ast& ast) {
	const SequentialIdentifierList& sequentialIdentifierList = dynamic_cast<const SequentialIdentifierList&>(ast);

	IdentifierList::operator=(ast);
	this->identifierList = sequentialIdentifierList.identifierList ? dynamic_cast<IdentifierList*>(&(sequentialIdentifierList.identifierList->clone())) : 0;
	this->simpleIdentifierList = sequentialIdentifierList.simpleIdentifierList ? dynamic_cast<SimpleIdentifierList*>(&(sequentialIdentifierList.simpleIdentifierList->clone())) : 0;

	return *(this);
}

bool SequentialIdentifierList::operator == (const Ast& ast) const {
	bool result = false;
	const SequentialIdentifierList& sequentialIdentifierList = dynamic_cast<const SequentialIdentifierList&>(ast);

	if (typeid(ast) != typeid(SequentialIdentifierList))
		return false;

	if (this->identifierList && this->simpleIdentifierList)
		result = (*(this->identifierList) == *(sequentialIdentifierList.identifierList) &&
				  *(this->simpleIdentifierList) == *(sequentialIdentifierList.simpleIdentifierList));

	return result && IdentifierList::operator==(ast);
}

