#ifndef SEQUENTIAL_IDENTIFIER_LIST_H
#define SEQUENTIAL_IDENTIFIER_LIST_H

#include "identifierlist.h"
#include "simpleidentifierlist.h"

class SequentialIdentifierList : public IdentifierList {
	private:
		IdentifierList *identifierList;
		SimpleIdentifierList *simpleIdentifierList;


	public:
		SequentialIdentifierList(SrcPosition *position, IdentifierList *identifierList, SimpleIdentifierList *simpleIdentifierList)
			: IdentifierList(position), identifierList(identifierList), simpleIdentifierList(simpleIdentifierList) {}

		SequentialIdentifierList(const SequentialIdentifierList& sequentialIdentifierList) : IdentifierList(sequentialIdentifierList.position) {
			*(this) = sequentialIdentifierList;
		}

		virtual ~SequentialIdentifierList() {
			delete this->identifierList;
			delete this->simpleIdentifierList;
		}

		IdentifierList *getIdentifierList() {
			return this->identifierList;
		}

		SimpleIdentifierList *getSimpleIdentifierList() {
			return this->simpleIdentifierList;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitSequentialIdentifierList(this);
		}

		virtual Ast& clone() const {
			return *(new SequentialIdentifierList(new SrcPosition(*(this->position)),
					 this->identifierList ? dynamic_cast<IdentifierList*>(&(this->identifierList->clone())) : 0,
					 this->simpleIdentifierList ? dynamic_cast<SimpleIdentifierList*>(&(this->simpleIdentifierList->clone())) : 0));
		}
};

#endif
