#include <typeinfo>
#include "sequentialimport.h"
using namespace std;

Ast& SequentialImport::operator = (const Ast& ast) {
	const SequentialImport& sequentialImport = dynamic_cast<const SequentialImport&>(ast);

	Import::operator=(ast);
	this->import = sequentialImport.import ? dynamic_cast<Import*>(&(sequentialImport.import->clone())) : 0;
	this->simpleImport = sequentialImport.simpleImport ? dynamic_cast<SimpleImport*>(&(sequentialImport.simpleImport->clone())) : 0;

	return *(this);
}

bool SequentialImport::operator == (const Ast& ast) const {
	bool result = false;
	const SequentialImport& sequentialImport = dynamic_cast<const SequentialImport&>(ast);

	if (typeid(ast) != typeid(SequentialImport))
		return false;

	if (this->import && this->simpleImport)
		result = (*(this->import) == *(sequentialImport.import) &&
				  *(this->simpleImport) == *(sequentialImport.simpleImport));

	return result && Import::operator==(ast);
}

