#include <typeinfo>
#include "sequentialleftsidelist.h"
using namespace std;

Ast& SequentialLeftSideList::operator = (const Ast& ast) {
	const SequentialLeftSideList& sequentialLeftSideList = dynamic_cast<const SequentialLeftSideList&>(ast);

	LeftSideList::operator=(ast);
	this->leftSideList = sequentialLeftSideList.leftSideList ? dynamic_cast<LeftSideList*>(&(sequentialLeftSideList.leftSideList->clone())) : 0;
	this->simpleLeftSideList = sequentialLeftSideList.simpleLeftSideList ? dynamic_cast<SimpleLeftSideList*>(&(sequentialLeftSideList.simpleLeftSideList->clone())) : 0;

	return *(this);
}

bool SequentialLeftSideList::operator == (const Ast& ast) const {
	bool result = false;
	const SequentialLeftSideList& sequentialLeftSideList = dynamic_cast<const SequentialLeftSideList&>(ast);

	if (typeid(ast) != typeid(SequentialLeftSideList))
		return false;

	if (this->leftSideList && this->simpleLeftSideList)
		result = (*(this->leftSideList) == *(sequentialLeftSideList.leftSideList) &&
				  *(this->simpleLeftSideList) == *(sequentialLeftSideList.simpleLeftSideList));

	return result && LeftSideList::operator==(ast);
}

