#include <typeinfo>
#include "sequentialmessage.h"
using namespace std;

Ast& SequentialMessage::operator = (const Ast& ast) {
	const SequentialMessage& sequentialMessage = dynamic_cast<const SequentialMessage&>(ast);

	Message::operator=(ast);
	this->message = sequentialMessage.message ? dynamic_cast<Message*>(&(sequentialMessage.message->clone())) : 0;
	this->simpleMessage = sequentialMessage.simpleMessage ? dynamic_cast<SimpleMessage*>(&(sequentialMessage.simpleMessage->clone())) : 0;

	return *(this);
}

bool SequentialMessage::operator == (const Ast& ast) const {
	bool result = false;
	const SequentialMessage& sequentialMessage = dynamic_cast<const SequentialMessage&>(ast);

	if (typeid(ast) != typeid(SequentialMessage))
		return false;

	if (this->message && this->simpleMessage)
		result = (*(this->message) == *(sequentialMessage.message) &&
				  *(this->simpleMessage) == *(sequentialMessage.simpleMessage));

	return result && Message::operator==(ast);
}

