#ifndef SEQUENTIAL_MESSAGE_H
#define SEQUENTIAL_MESSAGE_H

#include "message.h"
#include "simplemessage.h"

class SequentialMessage : public Message {
	private:
		Message *message;
		SimpleMessage *simpleMessage;


	public:
		SequentialMessage(SrcPosition *position, Message *message, SimpleMessage *simpleMessage)
			: Message(position), message(message), simpleMessage(simpleMessage) {}

		SequentialMessage(const SequentialMessage& sequentialMessage) : Message(sequentialMessage.position) {
			*(this) = sequentialMessage;
		}

		virtual ~SequentialMessage() {
			delete this->message;
			delete this->simpleMessage;
		}

		Message *getMessage() {
			return this->message;
		}

		SimpleMessage *getSimpleMessage() {
			return this->simpleMessage;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitSequentialMessage(this);
		}

		virtual Ast& clone() const {
			return *(new SequentialMessage(new SrcPosition(*(this->position)),
					 this->message ? dynamic_cast<Message*>(&(this->message->clone())) : 0,
					 this->simpleMessage ? dynamic_cast<SimpleMessage*>(&(this->simpleMessage->clone())) : 0));
		}
};

#endif
