#include <typeinfo>
#include "sequentialprocess.h"
using namespace std;

Ast& SequentialProcess::operator = (const Ast& ast) {
	const SequentialProcess& sequentialProcess = dynamic_cast<const SequentialProcess&>(ast);

	Process::operator=(ast);
	this->process = sequentialProcess.process ? dynamic_cast<Process*>(&(sequentialProcess.process->clone())) : 0;
	this->simpleProcess = sequentialProcess.simpleProcess ? dynamic_cast<SimpleProcess*>(&(sequentialProcess.simpleProcess->clone())) : 0;

	return *(this);
}

bool SequentialProcess::operator == (const Ast& ast) const {
	bool result = false;
	const SequentialProcess& sequentialProcess = dynamic_cast<const SequentialProcess&>(ast);

	if (typeid(ast) != typeid(SequentialProcess))
		return false;

	if (this->process && this->simpleProcess)
		result = (*(this->process) == *(sequentialProcess.process) &&
				  *(this->simpleProcess) == *(sequentialProcess.simpleProcess));

	return result && Process::operator==(ast);
}

