#include <typeinfo>
#include "sequentialstatement.h"
using namespace std;

Ast& SequentialStatement::operator = (const Ast& ast) {
	const SequentialStatement& sequentialStatement = dynamic_cast<const SequentialStatement&>(ast);

	Statement::operator=(ast);
	this->statement = sequentialStatement.statement ? dynamic_cast<Statement*>(&(sequentialStatement.statement->clone())) : 0;
	this->simpleStatement = sequentialStatement.simpleStatement ? dynamic_cast<SimpleStatement*>(&(sequentialStatement.simpleStatement->clone())) : 0;

	return *(this);
}

bool SequentialStatement::operator == (const Ast& ast) const {
	bool result = false;
	const SequentialStatement& sequentialStatement = dynamic_cast<const SequentialStatement&>(ast);

	if (typeid(ast) != typeid(SequentialStatement))
		return false;

	if (this->statement && this->simpleStatement)
		result = (*(this->statement) == *(sequentialStatement.statement) &&
				  *(this->simpleStatement) == *(sequentialStatement.simpleStatement));

	return result && Statement::operator==(ast);
}

