#ifndef SIMPLE_BEHAVIOR_H
#define SIMPLE_BEHAVIOR_H

#include "behavior.h"
#include "identifierlist.h"

class SimpleBehavior : public Behavior {
	private:
		IdentifierList *identifierList;

	public:
		SimpleBehavior(SrcPosition *position, IdentifierList *identifierList)
			: Behavior(position), identifierList(identifierList) {}

		SimpleBehavior(const SimpleBehavior& simpleBehavior) : Behavior(simpleBehavior.position) {
			*(this) = simpleBehavior;
		}

		virtual ~SimpleBehavior() {
			delete this->identifierList;
		}

		IdentifierList *getIdentifierList() {
			return this->identifierList;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitSimpleBehavior(this);
		}

		virtual Ast& clone() const {
			return *(new SimpleBehavior(new SrcPosition(*(this->position)),
					 this->identifierList ? dynamic_cast<IdentifierList*>(&(this->identifierList->clone())) : 0));
		}
};

#endif
