#include <typeinfo>
#include "simpleguardedstatement.h"
using namespace std;

Ast& SimpleGuardedStatement::operator = (const Ast& ast) {
	const SimpleGuardedStatement& simpleGuardedStatement = dynamic_cast<const SimpleGuardedStatement&>(ast);

	GuardedStatement::operator=(ast);
	this->expression = simpleGuardedStatement.expression ? dynamic_cast<Expression*>(&(simpleGuardedStatement.expression->clone())) : 0;
	this->statement = simpleGuardedStatement.statement ? dynamic_cast<Statement*>(&(simpleGuardedStatement.statement->clone())) : 0;

	return *(this);
}

bool SimpleGuardedStatement::operator == (const Ast& ast) const {
	bool result = false;
	const SimpleGuardedStatement& simpleGuardedStatement = dynamic_cast<const SimpleGuardedStatement&>(ast);

	if (typeid(ast) != typeid(SimpleGuardedStatement))
		return false;

	if (this->expression && this->statement)
		result = (*(this->expression) == *(simpleGuardedStatement.expression) &&
				   *(this->statement) == *(simpleGuardedStatement.statement));

	return result && GuardedStatement::operator==(ast);
}

