#ifndef SIMPLE_LEFT_SIDE_LIST_H
#define SIMPLE_LEFT_SIDE_LIST_H

#include "leftsidelist.h"
#include "leftside.h"

class SimpleLeftSideList : public LeftSideList {
	private:
		LeftSide *leftSide;

	public:
		SimpleLeftSideList(SrcPosition *position, LeftSide *leftSide)
			: LeftSideList(position), leftSide(leftSide) {}

		SimpleLeftSideList(const SimpleLeftSideList& simpleLeftSideList) : LeftSideList(simpleLeftSideList.position) {
			*(this) = simpleLeftSideList;
		}

		virtual ~SimpleLeftSideList() {
			delete this->leftSide;
		}

		LeftSide *getLeftSide() {
			return this->leftSide;
		}

		virtual Ast& operator = (const Ast& ast);
		virtual bool operator == (const Ast& ast) const;

		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitSimpleLeftSideList(this);
		}

		virtual Ast& clone() const {
			return *(new SimpleLeftSideList(new SrcPosition(*(this->position)),
					 this->leftSide ? dynamic_cast<LeftSide*>(&(this->leftSide->clone())) : 0));
		}
};

#endif
