#include <typeinfo>
#include "simpleprocess.h"
using namespace std;

Ast& SimpleProcess::operator = (const Ast& ast) {
	const SimpleProcess& simpleProcess = dynamic_cast<const SimpleProcess&>(ast);

	Process::operator=(ast);
	this->identifier = simpleProcess.identifier ? dynamic_cast<Identifier*>(&(simpleProcess.identifier->clone())) : 0;
	this->declaration = simpleProcess.declaration ? dynamic_cast<Declaration*>(&(simpleProcess.declaration->clone())) : 0;
	this->action = simpleProcess.action ? dynamic_cast<Action*>(&(simpleProcess.action->clone())) : 0;
	this->server = simpleProcess.server;

	return *(this);
}

bool SimpleProcess::operator == (const Ast& ast) const {
	bool result = false;
	const SimpleProcess& simpleProcess = dynamic_cast<const SimpleProcess&>(ast);

	if (typeid(ast) != typeid(SimpleProcess))
		return false;

	if (this->identifier && this->declaration && this->action)
		result = (*(this->identifier) == *(simpleProcess.identifier) &&
				   *(this->declaration) == *(simpleProcess.declaration) &&
				   *(this->action) == *(simpleProcess.action) &&
				   this->server == simpleProcess.server);

	return result && Process::operator==(ast);
}

