#ifndef SKIP_STATEMENT_H
#define SKIP_STATEMENT_H

#include "simplestatement.h"

class SkipStatement : public SimpleStatement {
	private:

	public:
		SkipStatement(SrcPosition *position)
				: SimpleStatement(position) {}

		virtual ~SkipStatement() {
		}

		virtual Ast& operator = (const Ast& ast) {
			Ast::operator=(ast);
			return *(this);
		}
		virtual bool operator == (const Ast& ast) const {
			return Ast::operator==(ast);
		}
		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitSkipStatement(this);
		}
		virtual Ast& clone() const {
			return *(new SkipStatement(new SrcPosition(*this->position)));
		}
};

#endif
