#ifndef SRC_POSITION_H
#define SRC_POSITION_H


/**
 * Classe responsavel por guardar informacao 
 * sobre a localizacao de um elemento da AST 
 * no codigo fonte
 */

class SrcPosition {
	private:
		int line;
	public:
		SrcPosition(int line) : line(line) {}
		SrcPosition(const SrcPosition& copy) : line(copy.line) {}

		virtual ~SrcPosition() {}

		int getLine() const { return this->line; }

		SrcPosition& operator = (const SrcPosition& srcPosition) {
			this->line = srcPosition.line;

			return *this;
		}
		
		bool operator == (const SrcPosition& srcPosition) const {
			return this->line == srcPosition.line;
		}

};

#endif
