#ifndef STRING_LITERAL_H
#define STRING_LITERAL_H
#include "expression.h"
#include <string>

using namespace std;

class StringLiteral : public Expression {
	private:
		string str;
	public:
		StringLiteral(SrcPosition *position, string str) : Ast(position), Expression(position), str(str) {}
		StringLiteral(const StringLiteral& stringLiteral) : Ast(position), Expression(position), str(stringLiteral.str) {}
		virtual ~StringLiteral() {}

		string &getStr() {
			return this->str;
		}

		virtual Ast& operator = (const Ast& ast);

		virtual bool operator == (const Ast& ast) const;
		
		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitStringLiteral(this);
		}

		virtual Ast& clone() const {
			return *(new StringLiteral(new SrcPosition(*this->position), this->str));
		}
};

#endif
