#ifndef TYPE_H
#define TYPE_H

#include "ast.h"

class Type : public Ast {
	public:
		enum types {INTEGER, BOOLEAN, RANGE, ADDRESS, CLIENT_ADDRESS,
					SERVER_ADDRESS, ARRAY, BEHAVIOR, TIMEOUT, MESSAGE, STRING,
					PROCESS};
		
		Type(SrcPosition *position, types typeCode_)
				: Ast(position), typeCode(typeCode_) {}

		virtual ~Type() {
		}

		virtual Ast& operator = (const Ast& ast) {
			const Type& type = dynamic_cast<const Type&>(ast);
			Ast::operator=(ast);
			this->typeCode = type.typeCode;
			
			return (*this);
		}
		virtual bool operator == (const Ast& ast) const {
			const Type& type = dynamic_cast<const Type&>(ast);
			return (this->typeCode == type.typeCode) && Ast::operator==(ast);
		}
		virtual VisitorReturn *visit(Visitor& visitor) {
			return visitor.visitType(this);
		}
		
		types getTypeCode() const {
			return this->typeCode;
		}
		
		virtual Ast& clone() const {
			return *(new Type(new SrcPosition(*this->position), this->typeCode));
		}
	
	protected:
		types typeCode;
};

#endif
