#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "cpmqueue.h"
#include "cpmengine.h"
#include "cpmsocketlist.h"

PMQueue *messageQueue;
extern PMSocket *protocolAddress;
extern PMSocketList *socketList;

int addrparse(void);

int initPMEngine(int argc, char **argv, char *name, int qntMsgTypes) {
	extern FILE *addrin;
	int ret = 0;
	int opt;
	char *inputFile = "";

	opterr = 0;
	do {
		opt = getopt(argc, argv, "+:a:");
		switch (opt) {
			case 'a':
                inputFile = strdup(optarg);

				addrin = fopen(inputFile, "r");
				if (addrin == NULL) {
					fprintf(stderr,
							"%s no  um arquivo de endereos vlido!\n",
							inputFile);
					ret = ENGINE_ERROR;
				}
				break;

			case '?':
                printf("-%c no  uma opo vlida!\n", optopt);
                ret = ENGINE_ERROR;
                break;

            case ':':
                printf("Falta um argumento para -%c!\n", optopt);
                ret = ENGINE_ERROR;
                break;

			default:
				break;
		}
	} while (opt != -1);

	if (inputFile == "") {
		fprintf(stderr, "Uso: %s -a addressFile\n", name);
		ret = ENGINE_ERROR;
	}

	else {
		free(inputFile);
		if (ret != ENGINE_ERROR && addrin) {
			ret = addrparse();

			if (ret != ENGINE_ERROR)
				messageQueue = pmqueue_new(qntMsgTypes);
		}
	}

	return ret;
}

void cleanupPMEngine() {
	pmsocket_close(protocolAddress);
	pmsocketlist_destroy(socketList);
    pmqueue_destroy(&messageQueue);
}
